; +
;   .  SEH.
; o SysStub -   (. call dword ptr ds:[RtlpStartThreadFunc]).
;
ConfigureConfigDirectory proc uses ebx esi edi SysStub:PVOID, pZwProtectVirtualMemory:PVOID
Local RegionAddress:PVOID, RegionSize:ULONG, Protect:ULONG
	mov eax,fs:[TEB.Peb]
	mov eax,PEB.Ldr[eax]
	mov eax,PEB_LDR_DATA.InLoadOrderModuleList.Flink[eax]
	mov eax,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[eax]
	mov ebx,LDR_DATA_TABLE_ENTRY.DllBase[eax]	; ntdll.dll
	mov edi,ebx
	add edi,IMAGE_DOS_HEADER.e_lfanew[ebx]
	assume edi:PIMAGE_NT_HEADERS
	mov esi,[edi].OptionalHeader.DataDirectory.VirtualAddress[IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG * sizeof(IMAGE_DATA_DIRECTORY)]
	mov RegionAddress,edi
	test esi,esi
	jz Error
	add esi,ebx	; _load_config_used
	assume esi:PIMAGE_LOAD_CONFIG_DIRECTORY
	cmp [esi]._Size,sizeof(IMAGE_LOAD_CONFIG_DIRECTORY)
	jne Error
	cmp [esi].SEHandlerCount,0
	movzx ecx,[edi].FileHeader.NumberOfSections
	je Error
	test ecx,ecx
	jz Error
Scan:
	cmp dword ptr IMAGE_SECTION_HEADER._Name[edi + sizeof(IMAGE_NT_HEADERS)][0],"tad."
	jne Next
	cmp dword ptr IMAGE_SECTION_HEADER._Name[edi + sizeof(IMAGE_NT_HEADERS)][4],"a"
	jne Next
	mov eax,IMAGE_SECTION_HEADER.Characteristics[edi + sizeof(IMAGE_NT_HEADERS)]
	and eax,IMAGE_SCN_MEM_WRITE or IMAGE_SCN_MEM_READ or IMAGE_SCN_CNT_INITIALIZED_DATA
	cmp eax,IMAGE_SCN_MEM_WRITE or IMAGE_SCN_MEM_READ or IMAGE_SCN_CNT_INITIALIZED_DATA
	jne Error
	mov eax,IMAGE_SECTION_HEADER.VirtualSize[edi + sizeof(IMAGE_NT_HEADERS)]
	mov ecx,[esi].SEHandlerCount
	and eax,(X86_PAGE_SIZE - 1)
	lea ecx,[ecx*4 + sizeof(IMAGE_LOAD_CONFIG_DIRECTORY) + 4]
	not eax
	lea eax,[eax + X86_PAGE_SIZE + 1]
	cld
	cmp eax,ecx
	mov edx,IMAGE_SECTION_HEADER.VirtualAddress[edi + sizeof(IMAGE_NT_HEADERS)]
	jb Error
	mov edi,IMAGE_SECTION_HEADER.VirtualSize[edi + sizeof(IMAGE_NT_HEADERS)]
	add edi,edx
	mov RegionSize,4
	add edi,ebx
	mov ecx,sizeof(IMAGE_LOAD_CONFIG_DIRECTORY)/4
	mov edx,edi
	assume edx:PIMAGE_LOAD_CONFIG_DIRECTORY
	rep movsd
	mov esi,[edx].SEHandlerTable
	mov ecx,[edx].SEHandlerCount
	mov [edx].SEHandlerTable,edi
	mov eax,SysStub
	rep movsd
	sub eax,ebx
	mov esi,RegionAddress
	stosd
	inc [edx].SEHandlerCount
	lea eax,Protect
	lea ecx,RegionSize
	mov edi,edx
	push eax
	push PAGE_READWRITE
	lea eax,RegionAddress
	push ecx
	push eax
	push NtCurrentProcess
	%APICALL pZwProtectVirtualMemory, 5
	test eax,eax
	jnz Exit
	sub edi,ebx
	mov IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG * sizeof(IMAGE_DATA_DIRECTORY)][esi],edi
	lea eax,Protect
	lea ecx,RegionSize
	push eax
	push Protect
	lea eax,RegionAddress
	push ecx
	push eax
	push NtCurrentProcess
	%APICALL pZwProtectVirtualMemory, 5
	xor eax,eax
	jmp Exit
Next:
	add edi,sizeof(IMAGE_SECTION_HEADER)
	dec ecx
	jnz Scan
Error:
	mov eax,STATUS_UNSUCCESSFUL
Exit:
	ret
ConfigureConfigDirectory endp